diff --git a/sys/bus/u4b/input/atp.c b/sys/bus/u4b/input/atp.c
index de02b38151..b456bf97f1 100644
--- a/sys/bus/u4b/input/atp.c
+++ b/sys/bus/u4b/input/atp.c
@@ -1760,92 +2314,27 @@ static void
 atp_intr(struct usb_xfer *xfer, usb_error_t error)
 {
 	struct atp_softc      *sc = usbd_xfer_softc(xfer);
-	int                    len;
 	struct usb_page_cache *pc;
-	uint8_t                status_bits;
-	atp_pspan  pspans_x[ATP_MAX_PSPANS_PER_AXIS];
-	atp_pspan  pspans_y[ATP_MAX_PSPANS_PER_AXIS];
-	u_int      n_xpspans = 0, n_ypspans = 0;
-	u_int      reaped_xlocs[ATP_MAX_STROKES];
-	u_int      tap_fingers = 0;
+	int len;
 
 	usbd_xfer_status(xfer, &len, NULL, NULL, NULL);
 
 	switch (USB_GET_STATE(xfer)) {
 	case USB_ST_TRANSFERRED:
-		if (len > sc->sc_params->data_len) {
-			DPRINTFN(ATP_LLEVEL_ERROR,
-			    "truncating large packet from %u to %u bytes\n",
-			    len, sc->sc_params->data_len);
-			len = sc->sc_params->data_len;
-		}
-		if (len < sc->sc_params->data_len)
-			goto tr_setup;
-
 		pc = usbd_xfer_get_frame(xfer, 0);
-		usbd_copy_out(pc, 0, sc->sensor_data, sc->sc_params->data_len);
-
-		/* Interpret sensor data */
-		atp_interpret_sensor_data(sc->sensor_data,
-		    sc->sc_params->n_xsensors, X, sc->cur_x,
-		    sc->sc_params->prot);
-		atp_interpret_sensor_data(sc->sensor_data,
-		    sc->sc_params->n_ysensors, Y,  sc->cur_y,
-		    sc->sc_params->prot);
-
-		/*
-		 * If this is the initial update (from an untouched
-		 * pad), we should set the base values for the sensor
-		 * data; deltas with respect to these base values can
-		 * be used as pressure readings subsequently.
-		 */
-		status_bits = sc->sensor_data[sc->sc_params->data_len - 1];
-		if ((sc->sc_params->prot == ATP_PROT_GEYSER3 &&
-		    (status_bits & ATP_STATUS_BASE_UPDATE)) ||
-		    !(sc->sc_state & ATP_VALID)) {
-			memcpy(sc->base_x, sc->cur_x,
-			    sc->sc_params->n_xsensors * sizeof(*(sc->base_x)));
-			memcpy(sc->base_y, sc->cur_y,
-			    sc->sc_params->n_ysensors * sizeof(*(sc->base_y)));
-			sc->sc_state |= ATP_VALID;
-			goto tr_setup;
+		usbd_copy_out(pc, 0, sc->sc_sensor_data, len);
+		if (len < sc->sc_expected_sensor_data_len) {
+			/* make sure we don't process old data */
+			memset(sc->sc_sensor_data + len, 0,
+			    sc->sc_expected_sensor_data_len - len);
 		}
 
-		/* Get pressure readings and detect p-spans for both axes. */
-		atp_get_pressures(sc->pressure_x, sc->cur_x, sc->base_x,
-		    sc->sc_params->n_xsensors);
-		atp_detect_pspans(sc->pressure_x, sc->sc_params->n_xsensors,
-		    ATP_MAX_PSPANS_PER_AXIS,
-		    pspans_x, &n_xpspans);
-		atp_get_pressures(sc->pressure_y, sc->cur_y, sc->base_y,
-		    sc->sc_params->n_ysensors);
-		atp_detect_pspans(sc->pressure_y, sc->sc_params->n_ysensors,
-		    ATP_MAX_PSPANS_PER_AXIS,
-		    pspans_y, &n_ypspans);
-
-		/* Update strokes with new pspans to detect movements. */
-		sc->sc_status.flags &= ~MOUSE_POSCHANGED;
-		if (atp_update_strokes(sc,
-			pspans_x, n_xpspans,
-			pspans_y, n_ypspans))
-			sc->sc_status.flags |= MOUSE_POSCHANGED;
-
-		/* Reap zombies if it is time. */
-		if (sc->sc_state & ATP_ZOMBIES_EXIST) {
-			struct timeval now;
-
-			getmicrotime(&now);
-			if (timevalcmp(&now, &sc->sc_reap_time, >=))
-				atp_reap_zombies(sc, &tap_fingers,
-				    reaped_xlocs);
-		}
-
-		sc->sc_status.flags &= ~MOUSE_STDBUTTONSCHANGED;
+		sc->sc_status.flags &= ~(MOUSE_STDBUTTONSCHANGED |
+		    MOUSE_POSCHANGED);
 		sc->sc_status.obutton = sc->sc_status.button;
 
-		/* Get the state of the physical buttton. */
-		sc->sc_status.button = (status_bits & ATP_STATUS_BUTTON) ?
-			MOUSE_BUTTON1DOWN : 0;
+		(sc->sensor_data_interpreter)(sc, len);
+
 		if (sc->sc_status.button != 0) {
 			/* Reset DOUBLE_TAP_N_DRAG if the button is pressed. */
 			sc->sc_state &= ~ATP_DOUBLE_TAP_DRAG;
@@ -1855,108 +2344,67 @@ atp_intr(struct usb_xfer *xfer, usb_error_t error)
 		}
 
 		sc->sc_status.flags |=
-			sc->sc_status.button ^ sc->sc_status.obutton;
+		    sc->sc_status.button ^ sc->sc_status.obutton;
 		if (sc->sc_status.flags & MOUSE_STDBUTTONSCHANGED) {
-			DPRINTFN(ATP_LLEVEL_INFO, "button %s\n",
-			    ((sc->sc_status.button & MOUSE_BUTTON1DOWN) ?
-				"pressed" : "released"));
-		} else if ((sc->sc_status.obutton == 0) &&
-		    (sc->sc_status.button == 0) &&
-		    (tap_fingers != 0)) {
-			/* Ignore single-finger taps at the edges. */
-			if ((tap_fingers == 1) &&
-			    ((reaped_xlocs[0] <= sc->sc_left_margin) ||
-				(reaped_xlocs[0] > sc->sc_right_margin))) {
-				tap_fingers = 0;
-			}
-			DPRINTFN(ATP_LLEVEL_INFO,
-			    "tap_fingers: %u\n", tap_fingers);
+		    DPRINTFN(ATP_LLEVEL_INFO, "button %s\n",
+			((sc->sc_status.button & MOUSE_BUTTON1DOWN) ?
+			"pressed" : "released"));
 		}
 
-		if (sc->sc_status.flags &
-		    (MOUSE_POSCHANGED | MOUSE_STDBUTTONSCHANGED)) {
-			int   dx, dy;
-			u_int n_movements;
+		if (sc->sc_status.flags & (MOUSE_POSCHANGED |
+		    MOUSE_STDBUTTONSCHANGED)) {
 
-			dx = 0, dy = 0, n_movements = 0;
-			for (u_int i = 0; i < sc->sc_n_strokes; i++) {
-				atp_stroke *stroke = &sc->sc_strokes[i];
+			atp_stroke_t *strokep;
+			u_int8_t n_movements = 0;
+			int dx = 0;
+			int dy = 0;
+			int dz = 0;
 
-				if ((stroke->components[X].movement) ||
-				    (stroke->components[Y].movement)) {
-					dx += stroke->components[X].movement;
-					dy += stroke->components[Y].movement;
+			TAILQ_FOREACH(strokep, &sc->sc_stroke_used, entry) {
+				if (strokep->flags & ATSF_ZOMBIE)
+					continue;
+
+				dx += strokep->movement_dx;
+				dy += strokep->movement_dy;
+				if (strokep->movement_dx ||
+				    strokep->movement_dy)
 					n_movements++;
-				}
 			}
-			/*
-			 * Disregard movement if multiple
-			 * strokes record motion.
-			 */
-			if (n_movements != 1)
-				dx = 0, dy = 0;
-
-			sc->sc_status.dx += dx;
-			sc->sc_status.dy += dy;
-			atp_add_to_queue(sc, dx, -dy, sc->sc_status.button);
-		}
 
-		if (tap_fingers != 0) {
-			/* Add a pair of events (button-down and button-up). */
-			switch (tap_fingers) {
-			case 1: atp_add_to_queue(sc, 0, 0, MOUSE_BUTTON1DOWN);
-				break;
-			case 2: atp_add_to_queue(sc, 0, 0, MOUSE_BUTTON2DOWN);
-				break;
-			case 3: atp_add_to_queue(sc, 0, 0, MOUSE_BUTTON3DOWN);
-				break;
-			default: break;/* handle taps of only up to 3 fingers */
+			/* average movement if multiple strokes record motion.*/
+			if (n_movements > 1) {
+				dx /= (int)n_movements;
+				dy /= (int)n_movements;
 			}
-			atp_add_to_queue(sc, 0, 0, 0); /* button release */
-		}
 
-		/*
-		 * The device continues to trigger interrupts at a
-		 * fast rate even after touchpad activity has
-		 * stopped. Upon detecting that the device has
-		 * remained idle beyond a threshold, we reinitialize
-		 * it to silence the interrupts.
-		 */
-		if ((sc->sc_status.flags  == 0) &&
-		    (sc->sc_n_strokes     == 0) &&
-		    (sc->sc_status.button == 0)) {
-			sc->sc_idlecount++;
-			if (sc->sc_idlecount >= ATP_IDLENESS_THRESHOLD) {
-				DPRINTFN(ATP_LLEVEL_INFO, "idle\n");
+			/* detect multi-finger vertical scrolls */
+			if (n_movements >= 2) {
+				boolean_t all_vertical_scrolls = true;
+				TAILQ_FOREACH(strokep, &sc->sc_stroke_used, entry) {
+					if (strokep->flags & ATSF_ZOMBIE)
+						continue;
 
-				/*
-				 * Use the last frame before we go idle for
-				 * calibration on pads which do not send
-				 * calibration frames.
-				 */
-				if (sc->sc_params->prot < ATP_PROT_GEYSER3) {
-					memcpy(sc->base_x, sc->cur_x,
-					    sc->sc_params->n_xsensors *
-					    sizeof(*(sc->base_x)));
-					memcpy(sc->base_y, sc->cur_y,
-					    sc->sc_params->n_ysensors *
-					    sizeof(*(sc->base_y)));
+					if (!atp_is_vertical_scroll(strokep))
+						all_vertical_scrolls = false;
+				}
+				if (all_vertical_scrolls) {
+					dz = dy;
+					dy = dx = 0;
 				}
-
-				sc->sc_idlecount = 0;
-				usbd_transfer_start(sc->sc_xfer[ATP_RESET]);
 			}
-		} else {
-			sc->sc_idlecount = 0;
+
+			sc->sc_status.dx += dx;
+			sc->sc_status.dy += dy;
+			sc->sc_status.dz += dz;
+			atp_add_to_queue(sc, dx, -dy, -dz, sc->sc_status.button);
 		}
 
 	case USB_ST_SETUP:
 	tr_setup:
 		/* check if we can put more data into the FIFO */
-		if (usb_fifo_put_bytes_max(
-			    sc->sc_fifo.fp[USB_FIFO_RX]) != 0) {
+		if (usb_fifo_put_bytes_max(sc->sc_fifo.fp[USB_FIFO_RX]) != 0) {
 			usbd_xfer_set_frame_len(xfer, 0,
-			    sc->sc_params->data_len);
+			    sc->sc_expected_sensor_data_len);
 			usbd_transfer_submit(xfer);
 		}
 		break;
@@ -1969,53 +2417,6 @@ atp_intr(struct usb_xfer *xfer, usb_error_t error)
 		}
 		break;
 	}
-
-	return;
-}
-
-static void
-atp_add_to_queue(struct atp_softc *sc, int dx, int dy, uint32_t buttons_in)
-{
-	uint32_t buttons_out;
-	uint8_t  buf[8];
-
-	dx = imin(dx,  254); dx = imax(dx, -256);
-	dy = imin(dy,  254); dy = imax(dy, -256);
-
-	buttons_out = MOUSE_MSC_BUTTONS;
-	if (buttons_in & MOUSE_BUTTON1DOWN)
-		buttons_out &= ~MOUSE_MSC_BUTTON1UP;
-	else if (buttons_in & MOUSE_BUTTON2DOWN)
-		buttons_out &= ~MOUSE_MSC_BUTTON2UP;
-	else if (buttons_in & MOUSE_BUTTON3DOWN)
-		buttons_out &= ~MOUSE_MSC_BUTTON3UP;
-
-	DPRINTFN(ATP_LLEVEL_INFO, "dx=%d, dy=%d, buttons=%x\n",
-	    dx, dy, buttons_out);
-
-	/* Encode the mouse data in standard format; refer to mouse(4) */
-	buf[0] = sc->sc_mode.syncmask[1];
-	buf[0] |= buttons_out;
-	buf[1] = dx >> 1;
-	buf[2] = dy >> 1;
-	buf[3] = dx - (dx >> 1);
-	buf[4] = dy - (dy >> 1);
-	/* Encode extra bytes for level 1 */
-	if (sc->sc_mode.level == 1) {
-		buf[5] = 0;                    /* dz */
-		buf[6] = 0;                    /* dz - (dz / 2) */
-		buf[7] = MOUSE_SYS_EXTBUTTONS; /* Extra buttons all up. */
-	}
-
-	usb_fifo_put_data_linear(sc->sc_fifo.fp[USB_FIFO_RX], buf,
-	    sc->sc_mode.packetsize, 1);
-}
-
-static void
-atp_reset_buf(struct atp_softc *sc)
-{
-	/* reset read queue */
-	usb_fifo_reset(sc->sc_fifo.fp[USB_FIFO_RX]);
 }
 
 static void
@@ -2046,56 +2447,57 @@ static void
 atp_stop_read(struct usb_fifo *fifo)
 {
 	struct atp_softc *sc = usb_fifo_softc(fifo);
-
 	usbd_transfer_stop(sc->sc_xfer[ATP_INTR_DT]);
 }
 
 static int
 atp_open(struct usb_fifo *fifo, int fflags)
 {
-	DPRINTFN(ATP_LLEVEL_INFO, "\n");
+	struct atp_softc *sc = usb_fifo_softc(fifo);
 
-	if (fflags & FREAD) {
-		struct atp_softc *sc = usb_fifo_softc(fifo);
-		int rc;
+	/* check for duplicate open, should not happen */
+	if (sc->sc_fflags & fflags)
+		return (EBUSY);
 
-		if (sc->sc_state & ATP_ENABLED)
-			return (EBUSY);
+	/* check for first open */
+	if (sc->sc_fflags == 0) {
+		int rc;
+		if ((rc = atp_enable(sc)) != 0)
+			return (rc);
+	}
 
+	if (fflags & FREAD) {
 		if (usb_fifo_alloc_buffer(fifo,
-			ATP_FIFO_BUF_SIZE, ATP_FIFO_QUEUE_MAXLEN)) {
+		    ATP_FIFO_BUF_SIZE, ATP_FIFO_QUEUE_MAXLEN)) {
 			return (ENOMEM);
 		}
-
-		rc = atp_enable(sc);
-		if (rc != 0) {
-			usb_fifo_free_buffer(fifo);
-			return (rc);
-		}
 	}
 
+	sc->sc_fflags |= (fflags & (FREAD | FWRITE));
 	return (0);
 }
 
 static void
 atp_close(struct usb_fifo *fifo, int fflags)
 {
-	if (fflags & FREAD) {
-		struct atp_softc *sc = usb_fifo_softc(fifo);
+	struct atp_softc *sc = usb_fifo_softc(fifo);
+	if (fflags & FREAD)
+		usb_fifo_free_buffer(fifo);
 
+	sc->sc_fflags &= ~(fflags & (FREAD | FWRITE));
+	if (sc->sc_fflags == 0) {
 		atp_disable(sc);
-		usb_fifo_free_buffer(fifo);
 	}
 }
 
-int
+static int
 atp_ioctl(struct usb_fifo *fifo, u_long cmd, void *addr, int fflags)
 {
 	struct atp_softc *sc = usb_fifo_softc(fifo);
 	mousemode_t mode;
 	int error = 0;
 
-	mtx_lock(&sc->sc_mutex);
+	lockmgr(&sc->sc_lock, LK_EXCLUSIVE);
 
 	switch(cmd) {
 	case MOUSE_GETHWINFO:
@@ -2112,20 +2514,20 @@ atp_ioctl(struct usb_fifo *fifo, u_long cmd, void *addr, int fflags)
 			;
 		else if ((mode.level < 0) || (mode.level > 1)) {
 			error = EINVAL;
-			goto done;
+			break;
 		}
 		sc->sc_mode.level = mode.level;
 		sc->sc_pollrate   = mode.rate;
 		sc->sc_hw.buttons = 3;
 
 		if (sc->sc_mode.level == 0) {
-			sc->sc_mode.protocol = MOUSE_PROTO_MSC;
-			sc->sc_mode.packetsize = MOUSE_MSC_PACKETSIZE;
+			sc->sc_mode.protocol    = MOUSE_PROTO_MSC;
+			sc->sc_mode.packetsize  = MOUSE_MSC_PACKETSIZE;
 			sc->sc_mode.syncmask[0] = MOUSE_MSC_SYNCMASK;
 			sc->sc_mode.syncmask[1] = MOUSE_MSC_SYNC;
 		} else if (sc->sc_mode.level == 1) {
-			sc->sc_mode.protocol = MOUSE_PROTO_SYSMOUSE;
-			sc->sc_mode.packetsize = MOUSE_SYS_PACKETSIZE;
+			sc->sc_mode.protocol    = MOUSE_PROTO_SYSMOUSE;
+			sc->sc_mode.packetsize  = MOUSE_SYS_PACKETSIZE;
 			sc->sc_mode.syncmask[0] = MOUSE_SYS_SYNCMASK;
 			sc->sc_mode.syncmask[1] = MOUSE_SYS_SYNC;
 		}
@@ -2135,21 +2537,21 @@ atp_ioctl(struct usb_fifo *fifo, u_long cmd, void *addr, int fflags)
 		*(int *)addr = sc->sc_mode.level;
 		break;
 	case MOUSE_SETLEVEL:
-		if (*(int *)addr < 0 || *(int *)addr > 1) {
+		if ((*(int *)addr < 0) || (*(int *)addr > 1)) {
 			error = EINVAL;
-			goto done;
+			break;
 		}
 		sc->sc_mode.level = *(int *)addr;
 		sc->sc_hw.buttons = 3;
 
 		if (sc->sc_mode.level == 0) {
-			sc->sc_mode.protocol = MOUSE_PROTO_MSC;
-			sc->sc_mode.packetsize = MOUSE_MSC_PACKETSIZE;
+			sc->sc_mode.protocol    = MOUSE_PROTO_MSC;
+			sc->sc_mode.packetsize  = MOUSE_MSC_PACKETSIZE;
 			sc->sc_mode.syncmask[0] = MOUSE_MSC_SYNCMASK;
 			sc->sc_mode.syncmask[1] = MOUSE_MSC_SYNC;
 		} else if (sc->sc_mode.level == 1) {
-			sc->sc_mode.protocol = MOUSE_PROTO_SYSMOUSE;
-			sc->sc_mode.packetsize = MOUSE_SYS_PACKETSIZE;
+			sc->sc_mode.protocol    = MOUSE_PROTO_SYSMOUSE;
+			sc->sc_mode.packetsize  = MOUSE_SYS_PACKETSIZE;
 			sc->sc_mode.syncmask[0] = MOUSE_SYS_SYNCMASK;
 			sc->sc_mode.syncmask[1] = MOUSE_SYS_SYNC;
 		}
@@ -2161,9 +2563,9 @@ atp_ioctl(struct usb_fifo *fifo, u_long cmd, void *addr, int fflags)
 		*status = sc->sc_status;
 		sc->sc_status.obutton = sc->sc_status.button;
 		sc->sc_status.button  = 0;
-		sc->sc_status.dx = 0;
-		sc->sc_status.dy = 0;
-		sc->sc_status.dz = 0;
+		sc->sc_status.dx      = 0;
+		sc->sc_status.dy      = 0;
+		sc->sc_status.dz      = 0;
 
 		if (status->dx || status->dy || status->dz)
 			status->flags |= MOUSE_POSCHANGED;
@@ -2171,12 +2573,13 @@ atp_ioctl(struct usb_fifo *fifo, u_long cmd, void *addr, int fflags)
 			status->flags |= MOUSE_BUTTONSCHANGED;
 		break;
 	}
+
 	default:
 		error = ENOTTY;
+		break;
 	}
 
-done:
-	mtx_unlock(&sc->sc_mutex);
+	lockmgr(&sc->sc_lock, LK_RELEASE);
 	return (error);
 }
 
@@ -2185,49 +2588,44 @@ atp_sysctl_scale_factor_handler(SYSCTL_HANDLER_ARGS)
 {
 	int error;
 	u_int tmp;
-	u_int prev_mickeys_scale_factor;
-
-	prev_mickeys_scale_factor = atp_mickeys_scale_factor;
 
 	tmp = atp_mickeys_scale_factor;
 	error = sysctl_handle_int(oidp, &tmp, 0, req);
 	if (error != 0 || req->newptr == NULL)
 		return (error);
 
-	if (tmp == prev_mickeys_scale_factor)
+	if (tmp == atp_mickeys_scale_factor)
 		return (0);     /* no change */
+	if ((tmp == 0) || (tmp > (10 * ATP_SCALE_FACTOR)))
+		return (EINVAL);
 
 	atp_mickeys_scale_factor = tmp;
 	DPRINTFN(ATP_LLEVEL_INFO, "%s: resetting mickeys_scale_factor to %u\n",
 	    ATP_DRIVER_NAME, tmp);
 
-	/* Update dependent thresholds. */
-	if (atp_small_movement_threshold == (prev_mickeys_scale_factor >> 3))
-		atp_small_movement_threshold = atp_mickeys_scale_factor >> 3;
-	if (atp_max_delta_mickeys == ((3 * prev_mickeys_scale_factor) >> 1))
-		atp_max_delta_mickeys = ((3 * atp_mickeys_scale_factor) >>1);
-	if (atp_slide_min_movement == (prev_mickeys_scale_factor >> 3))
-		atp_slide_min_movement = atp_mickeys_scale_factor >> 3;
-
 	return (0);
 }
 
+static devclass_t atp_devclass;
+
 static device_method_t atp_methods[] = {
-	/* Device interface */
 	DEVMETHOD(device_probe,  atp_probe),
 	DEVMETHOD(device_attach, atp_attach),
 	DEVMETHOD(device_detach, atp_detach),
+
 	DEVMETHOD_END
 };
 
 static driver_t atp_driver = {
-	ATP_DRIVER_NAME,
-	atp_methods,
-	sizeof(struct atp_softc)
+	.name    = ATP_DRIVER_NAME,
+	.methods = atp_methods,
+	.size    = sizeof(struct atp_softc)
 };
 
-static devclass_t atp_devclass;
-
-DRIVER_MODULE(atp, uhub, atp_driver, atp_devclass, NULL, NULL);
+DRIVER_MODULE(atp, uhub, atp_driver, atp_devclass, NULL, 0);
 MODULE_DEPEND(atp, usb, 1, 1, 1);
 MODULE_VERSION(atp, 1);
+#ifndef __DragonFly__
+USB_PNP_HOST_INFO(fg_devs);
+USB_PNP_HOST_INFO(wsp_devs);
+#endif
diff --git a/sys/bus/u4b/input/atp/Makefile b/sys/bus/u4b/input/atp/Makefile
new file mode 100644
index 0000000000..e4051112df
--- /dev/null
+++ b/sys/bus/u4b/input/atp/Makefile
@@ -0,0 +1,9 @@
+# $FreeBSD: head/sys/modules/usb/atp/Makefile 314651 2017-03-04 10:10:17Z ngie $
+
+.PATH:	${.CURDIR}/..
+
+KMOD=	atp
+SRCS=	opt_bus.h opt_usb.h device_if.h bus_if.h usb_if.h usbdevs.h \
+	atp.c
+
+.include <bsd.kmod.mk>
diff --git a/sys/bus/u4b/usbdevs b/sys/bus/u4b/usbdevs
index ed3468878d..fb8d012bc6 100644
--- a/sys/bus/u4b/usbdevs
+++ b/sys/bus/u4b/usbdevs
@@ -1080,6 +1080,58 @@ product APPLE KBD_TP_JIS	0x0225	Apple Internal Keyboard/Trackpad (Wellspring/JIS
 product APPLE KBD_TP_ANSI2	0x0230	Apple Internal Keyboard/Trackpad (Wellspring2/ANSI)
 product APPLE KBD_TP_ISO2	0x0231	Apple Internal Keyboard/Trackpad (Wellspring2/ISO)
 product APPLE KBD_TP_JIS2	0x0232	Apple Internal Keyboard/Trackpad (Wellspring2/JIS)
+/* MacbookAir, aka wellspring */
+product APPLE WELLSPRING_ANSI	0x0223	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING_ISO	0x0224	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING_JIS	0x0225	Apple Internal Keyboard/Trackpad
+/* MacbookProPenryn, aka wellspring2 */
+product APPLE WELLSPRING2_ANSI	0x0230	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING2_ISO	0x0231	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING2_JIS	0x0232	Apple Internal Keyboard/Trackpad
+/* Macbook5,1 (unibody), aka wellspring3 */
+product APPLE WELLSPRING3_ANSI	0x0236	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING3_ISO	0x0237	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING3_JIS	0x0238	Apple Internal Keyboard/Trackpad
+/* MacbookAir3,2 (unibody), aka wellspring4 */
+product APPLE WELLSPRING4_ANSI	0x023f	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING4_ISO	0x0240	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING4_JIS	0x0241	Apple Internal Keyboard/Trackpad
+/* MacbookAir3,1 (unibody), aka wellspring4 */
+product APPLE WELLSPRING4A_ANSI	0x0242	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING4A_ISO	0x0243	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING4A_JIS	0x0244	Apple Internal Keyboard/Trackpad
+/* Macbook8 (unibody, March 2011) */
+product APPLE WELLSPRING5_ANSI	0x0245	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING5_ISO	0x0246	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING5_JIS	0x0247	Apple Internal Keyboard/Trackpad
+/* MacbookAir4,1 (unibody, July 2011) */
+product APPLE WELLSPRING6A_ANSI	0x0249	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING6A_ISO	0x024a	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING6A_JIS	0x024b	Apple Internal Keyboard/Trackpad
+/* MacbookAir4,2 (unibody, July 2011) */
+product APPLE WELLSPRING6_ANSI	0x024c	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING6_ISO	0x024d	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING6_JIS	0x024e	Apple Internal Keyboard/Trackpad
+/* Macbook8,2 (unibody) */
+product APPLE WELLSPRING5A_ANSI	0x0252	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING5A_ISO	0x0253	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING5A_JIS	0x0254	Apple Internal Keyboard/Trackpad
+/* MacbookPro10,1 (unibody, June 2012) */
+product APPLE WELLSPRING7_ANSI	0x0262	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING7_ISO	0x0263	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING7_JIS	0x0264	Apple Internal Keyboard/Trackpad
+/* MacbookPro10,2 (unibody, October 2012) */
+product APPLE WELLSPRING7A_ANSI	0x0259	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING7A_ISO	0x025a	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING7A_JIS	0x025b	Apple Internal Keyboard/Trackpad
+/* MacbookAir6,2 (unibody, June 2013) */
+product APPLE WELLSPRING8_ANSI	0x0290	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING8_ISO	0x0291	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING8_JIS	0x0292	Apple Internal Keyboard/Trackpad
+/* MacbookPro12,1 */
+product APPLE WELLSPRING9_ANSI	0x0272	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING9_ISO	0x0273	Apple Internal Keyboard/Trackpad
+product APPLE WELLSPRING9_JIS	0x0274	Apple Internal Keyboard/Trackpad
 product APPLE MOUSE		0x0301	Mouse M4848
 product APPLE OPTMOUSE		0x0302	Optical mouse
 product APPLE MIGHTYMOUSE	0x0304	Mighty Mouse
-- 
2.11.0

